Index: /LMDZ.3.3/trunk/libf/dyn3d/grilles_gcm_netcdf.F
===================================================================
--- /LMDZ.3.3/trunk/libf/dyn3d/grilles_gcm_netcdf.F	(revision 203)
+++ /LMDZ.3.3/trunk/libf/dyn3d/grilles_gcm_netcdf.F	(revision 204)
@@ -1,3 +1,6 @@
+c
 c $Header
+c
+
       PROGRAM create_fausse_var
 C
@@ -9,4 +12,7 @@
 #include "comconst.h"
 #include "comgeom.h"
+#include "comvert.h"
+
+      real temp(iim+1,jjm+1)
 #include "netcdf.inc"
 
@@ -19,11 +25,9 @@
         integer*4 out_latudim,out_latvdim,out_dim(3)
 
-c   champs a faire disparaitre
-        real ucov(ijp1llm),vcov(ijmllm),teta(ijp1llm)
-        real masse(ijp1llm),ps(ip1jmp1),phis(ip1jmp1)
-        real q(ijp1llm*nqmx)
-        real time_0
-
-        real clesphy0(20),pa,preff
+      INTEGER         longcles
+      PARAMETER     ( longcles = 20 )
+      REAL  clesphy0( longcles )
+
+      integer start(4),count(4)
 
 	integer status,i,j
@@ -31,4 +35,11 @@
         real rlonudeg(iip1),rlonvdeg(iip1)
 
+      real dlon1(iip1),dlon2(iip1),dlat1(jjp1),dlat2(jjp1)
+      real acoslat,dxkm,dykm,resol(iip1,jjp1)
+
+#include "serre.h"
+#include "fxyprim.h"
+
+      print*,'OK0'
 
       rad = 6400000
@@ -42,16 +53,12 @@
       pa= 50000.
 
-c     CALL dynetat0("start.nc",nqmx,vcov,ucov,
-c    .              teta,q,masse,ps,phis, time_0)
-
-
       open(99,file='run.def',status='old',form='formatted')
-      CALL defrun_new( 99, .TRUE. ,clesphy0)
+      CALL defrun_new( 99, .TRUE.,clesphy0 )
       close(99)
       CALL iniconst
-      print*,'inigeom pas OK'
       CALL inigeom
-      print*,'inigeom OK'
-
+
+
+      print*,'OK1'
       do j=1,jjp1
          rlatudeg(j)=rlatu(j)*180./pi
@@ -66,5 +73,7 @@
       enddo
 
-      print*,'  2 ----- OUVERTURE DE LA SORTIE NETCDF'
+
+      print*,'OK2'
+c  2 ----- OUVERTURE DE LA SORTIE NETCDF
 c ---------------------------------------------------
 c CREATION OUTPUT
@@ -78,4 +87,6 @@
         status=NF_DEF_DIM(ncid_out,'latv',jjm,out_latvdim)
 
+
+      print*,'OK3'
 c   Longitudes en u
         print *,'OUTID: ',ncid_out
@@ -138,7 +149,19 @@
      %  16,'Grille aux point v')
 
-
+c   ecriture de la grille u
+        out_dim(1)=out_lonvdim
+        out_dim(2)=out_latudim
+        status=NF_DEF_VAR(ncid_out,'grille_s',NF_FLOAT,2,out_dim,
+     %  out_varid)
+        call handle_err(status)
+        status=NF_PUT_ATT_TEXT(ncid_out,out_varid,'units',
+     %  6,'Kelvin')
+        status=NF_PUT_ATT_TEXT(ncid_out,out_varid,'long_name',
+     %  16,'Grille aux point u')
+
+
+      print*,'OK4'
         status=NF_ENDDEF(ncid_out)
-        print*,' 5) ----- FERMETURE DES FICHIERS NETCDF-'
+c 5) ----- FERMETURE DES FICHIERS NETCDF------------------
 c --------------------------------------------------------
 c 3-b- Ecriture de la grille pour la sortie
@@ -150,4 +173,22 @@
         status=NF_PUT_VARA_REAL(ncid_out,out_latvid,1,jjm,rlatvdeg)
 
+        start(1)=1
+        start(2)=1
+        start(3)=1
+        start(4)=1
+
+        count(1)=iim+1
+        count(2)=jjm+1
+        count(3)=1
+        count(4)=1
+
+        do j=1,jjm+1
+           do i=1,iim+1
+              temp(i,j)=mod(i,2)+mod(j,2)
+           enddo
+        enddo
+
+        status=NF_PUT_VARA_REAL(ncid_out,out_varid,start,
+     s  count,temp)
 
 c fermeture du fichier netcdf
@@ -155,4 +196,64 @@
         write(*,*) 'Fermeture: ',fich_out
 
+
+      print*,'OK5'
+c   Ecriture grads
+      open (20,file='grille.dat',form='unformatted',access='direct'
+     s      ,recl=4*ip1jmp1)
+      write(20,rec=1) ((float(mod(i,2)+mod(j,2)),i=1,iip1),j=1,jjp1)
+      write(20,rec=2) ((float(mod(i,2)*mod(j,2)),i=1,iip1),j=1,jjp1)
+      do j=2,jjm
+         dlat1(j)=180.*(rlatv(j)-rlatv(j-1))/pi
+c        dlat2(j)=180.*fyprim(float(j))/pi
+      enddo
+      do i=2,iip1
+         dlon1(i)=180.*(rlonu(i)-rlonu(i-1))/pi
+c        dlon2(i)=180.*fxprim(float(i))/pi
+      enddo
+      do j=2,jjm
+         dykm=(rlatv(j)-rlatv(j-1))*6400.
+         acoslat=6400.*cos(rlatu(j))
+         do i=2,iip1
+            dxkm=acoslat*(rlonu(i)-rlonu(i-1))
+            resol(i,j)=sqrt(dykm*dykm+dxkm*dxkm)
+         enddo
+         resol(1,j)=resol(iip1,j)
+      enddo
+      write(20,rec=3) resol
+      dlon1(1)=dlon1(iip1)
+      dlon2(1)=dlon2(iip1)
+      write(20,rec=4) ((dlon1(i),i=1,iip1),j=1,jjp1)
+      write(20,rec=5) ((dlon2(i),i=1,iip1),j=1,jjp1)
+      write(20,rec=6) ((dlat1(j),i=1,iip1),j=1,jjp1)
+      write(20,rec=7) ((dlat2(j),i=1,iip1),j=1,jjp1)
+        
+      open (21,file='grille.ctl',form='formatted')
+
+c   WARNING! on reecrase le fichier .ctl a chaque ecriture
+      write(21,'(a5,1x,a40)')
+     &       'DSET ','^grille.dat'
+
+      write(21,'(a12)') 'UNDEF 1.0E30'
+      write(21,'(a5,1x,a40)') 'TITLE ','grille'
+      call formcoord(21,iip1,rlonv,180./pi,.false.,'XDEF')
+      call formcoord(21,jjp1,rlatu,180./pi,.true.,'YDEF')
+      call formcoord(21,1,0.,1.,.false.,'ZDEF')
+      write(21,'(a4,i10,a30)')
+     &       'TDEF ',1,' LINEAR 23OCT1994 3hr '
+      write(21,'(a4,2x,i5)') 'VARS',7
+      write(21,'(a18)') 'grille 0 99 grille'
+      write(21,'(a18)') 'gril   0 99 gril  '
+      write(21,'(a29)') 'resol   0 99 resolution (km)  '
+      write(21,'(a18)') 'dlon1  0 99 dlon1 '
+      write(21,'(a18)') 'dlon2  0 99 dlon2 '
+      write(21,'(a18)') 'dlat1  0 99 dlat1 '
+      write(21,'(a18)') 'dlat2  0 99 dlat2 '
+      write(21,'(a7)') 'ENDVARS'
+
+
+
+
+
+      print*,'OK6'
 	end
 
@@ -161,4 +262,6 @@
         subroutine handle_err(status)
 #include "netcdf.inc"
+
+
         integer status
         print *,'handle code err: ',NF_NOERR
Index: /LMDZ.3.3/trunk/libf/dyn3d/nudge.F
===================================================================
--- /LMDZ.3.3/trunk/libf/dyn3d/nudge.F	(revision 203)
+++ /LMDZ.3.3/trunk/libf/dyn3d/nudge.F	(revision 204)
@@ -99,7 +99,6 @@
      s   ,'1: en-ligne, 0: hors-ligne (x=x_rea), -1: climat (x=x_gcm)'
 cnec         read(*,*) online
-          online=-1
-         print*,'Entrer les constantes de temps de rappel en jours'
-         print*,'alphaT,alphau,alphav,alphaP'
+cnec      online=-1
+cnec     print*,'Entrer les constantes de temps de rappel en jours'
 cnec         read(*,*)alphaT
 cnec         read(*,*)alphau
@@ -110,4 +109,6 @@
              alphav=0.1
              alphaP=1.e10
+         print*,'alphaT,alphau,alphav,alphaP'
+     s          ,alphaT,alphau,alphav,alphaP
          if(online.eq.-1) return
          print*,'alpha rappel pour T, u, v, P ',
@@ -142,5 +143,5 @@
 c   Lecture du premier etat des reanalyses.
          call read_reanalyse(1
-     s   ,ucovrea2,vcovrea2,tetarea2,masserea2,psrea2,1)
+     s   ,ucovrea2,vcovrea2,tetarea2,masserea2,ps,1)
 
 c-----------------------------------------------------------------------
@@ -171,6 +172,6 @@
            CALL SCOPY( ijp1llm,ucovrea2, 1, ucovrea1 , 1 )
            CALL SCOPY( ijp1llm,tetarea2,1,tetarea1   , 1 )
-           CALL SCOPY( ijp1llm,masserea2,1,masserea1   , 1 )
-           CALL SCOPY( ip1jmp1,psrea2, 1,  psrea1, 1 )
+c          CALL SCOPY( ijp1llm,masserea2,1,masserea1   , 1 )
+c          CALL SCOPY( ip1jmp1,psrea2, 1,  psrea1, 1 )
 
           print*,'LECTURE REANALYSES, pas ',step_rea
@@ -179,5 +180,5 @@
            itau_test=itau
            call read_reanalyse(step_rea
-     s     ,ucovrea2,vcovrea2,tetarea2,masserea2,psrea2,1)
+     s     ,ucovrea2,vcovrea2,tetarea2,masserea2,ps,1)
         endif
       else
@@ -205,6 +206,6 @@
             a=(1.-tau)*tetarea1(ij,l)+tau*tetarea2(ij,l)
             teta(ij,l)=alphaT*teta(ij,l)+(1-alphaT)*a
-            a=(1.-tau)*masserea1(ij,l)+tau*masserea2(ij,l)
-            masse(ij,l)=alphaP*masse(ij,l)+(1-alphaP)*a
+c           a=(1.-tau)*masserea1(ij,l)+tau*masserea2(ij,l)
+c           masse(ij,l)=alphaP*masse(ij,l)+(1-alphaP)*a
          enddo
          do ij=1,ip1jm
Index: /LMDZ.3.3/trunk/libf/dyn3d/offlinenc.F
===================================================================
--- /LMDZ.3.3/trunk/libf/dyn3d/offlinenc.F	(revision 203)
+++ /LMDZ.3.3/trunk/libf/dyn3d/offlinenc.F	(revision 204)
@@ -1,2 +1,5 @@
+c
+c $Header
+c
       PROGRAM offlinenc
       USE ioipsl
@@ -66,5 +69,5 @@
 	integer iiinj
       integer jour0,isplit,nsplit_dyn,nsplit_phy,nsplit
-      logical debut,lectstart,rnpb
+      logical debut,lectstart,rnpb,lafin
 
       EXTERNAL inidissip,iniconst,inifilr
@@ -190,4 +193,9 @@
      .              teta,q,masse,ps,phis, time_0)
          print*,'Lecture du start'
+c  On zappe le radon et le plomb.
+         q(:,:,:,1)=q(:,:,:,3)
+         q(:,:,:,2)=q(:,:,:,4)
+c Initialisation d'un traceur ` 1 pour tester l'impact du lessivage.
+         q(:,:,:,3)=1.
       else
          day_ini=0
@@ -203,9 +211,9 @@
 C      print*,'av iniconst'
 c   lecture du jour de demarrage
-c    premiere initialisation, eventuellement bidon
-      CALL iniconst
+c    premiere cnitialisation, eventuellement bidon
+      cALL iniconst
       CALL inigeom
 C
-      print*,'ENTREE DANS redecoupenc ou lectfluxnc0
+      print*,'ENTREE DANS redecoupenc ou lectfluxnc
      s        pour irec=0'
 
@@ -219,5 +227,5 @@
      s     frac_impa,frac_nucl,phis)
       else
-         call lectfluxnc0(0,masse,pbaru,pbarv,w,teta,phi,
+         call lectfluxnc(0,masse,pbaru,pbarv,w,teta,phi,
      s     nrec,avant,airefi,pphis,
      s     t,zmfu, zmfd, zen_u, zde_u,zen_d, zde_d, coefkz,
@@ -373,5 +381,5 @@
      s     frac_impa,frac_nucl,phis)
       else
-         call lectfluxnc0(irec,masse,pbaru,pbarv,w,teta,phi,
+         call lectfluxnc(irec,masse,pbaru,pbarv,w,teta,phi,
      s     nrec,avant,airefi,pphis,
      s     t,zmfu, zmfd, zen_u, zde_u,zen_d, zde_d, coefkz,
@@ -380,4 +388,9 @@
       endif
 
+
+      print*,'TESTPHYS: ON PREND LA PUIS ',1./float(nsplit*nsplit_phy)
+     s   ,'  DES FRAC A IT=',itau
+      frac_impa(:,:)=frac_impa(:,:)**(1./float(nsplit*nsplit_phy))
+      frac_nucl(:,:)=frac_nucl(:,:)**(1./float(nsplit*nsplit_phy))
 c    ...  ouverture du fichier de stockage netcdf ...
 C
@@ -391,6 +404,6 @@
          mode=1
 
-         CALL initdynav(dynhistave_file,day_ini,anne_ini,dtav,
-     .              t_ops, t_wrt, nq,mode, histaveid)
+c        CALL initdynav(dynhistave_file,day_ini,anne_ini,dtav,
+c    .              t_ops, t_wrt, nq,mode, histaveid)
 
          pi=2.*asin(1.)
@@ -832,7 +845,11 @@
              do iii=1,nsplit_phy
 C
+      lafin=.false. ! en attendant mieux.
       print*,'dtphys avant phytrac ',dtphys
-             call phytrac(rnpb,
-     I                   ecritphy, debutphy,
+      print*,'TESTPHYS: APPEL A PHYTRAC IT=',itau
+
+             call phytrac(rnpb,ecritphy,
+c    I                   ecritphy, debutphy,
+     I                   debutphy, lafin,
      I                   nq,
      I                   ngridmx,llm,dtphys,
@@ -855,6 +872,6 @@
              itauav=(itau-1)*nsplit+isplit
 c             itauav=itau*nsplit+isplit
-             CALL writedynav(histaveid, nq,mode, itauav,vcov ,
-     ,                   ucov,teta,pk,phi,q,masse,ps,phis)
+c            CALL writedynav(histaveid, nq,mode, itauav,vcov ,
+c    ,                   ucov,teta,pk,phi,q,masse,ps,phis)
 c            qmoy(:,:,:)=qmoy(:,:,:)+q(:,:,1,:)
          do iq=1,nq
Index: /LMDZ.3.3/trunk/libf/dyn3d/read_reanalyse.F
===================================================================
--- /LMDZ.3.3/trunk/libf/dyn3d/read_reanalyse.F	(revision 203)
+++ /LMDZ.3.3/trunk/libf/dyn3d/read_reanalyse.F	(revision 204)
@@ -1,3 +1,5 @@
+c
 c $Header
+c
       subroutine read_reanalyse(timestep,u,v,t,masse,ps,mode)
 
@@ -14,5 +16,5 @@
       integer nlevnc
 cModef 11-2-99      parameter (nlevnc=15)
-      parameter (nlevnc=15)
+      parameter (nlevnc=21)
       integer timestep,mode,l
 
@@ -58,7 +60,7 @@
             varidt=NCVID(ncidt,'AIR',rcode)
             print*,'ncidt,varidt',ncidt,varidt
-            ncidps=NCOPN('ps.nc',NCNOWRIT,rcode)
-            varidps=NCVID(ncidps,'SP',rcode)
-            print*,'ncidps,varidps',ncidps,varidps
+c           ncidps=NCOPN('ps.nc',NCNOWRIT,rcode)
+c           varidps=NCVID(ncidps,'SP',rcode)
+c           print*,'ncidps,varidps',ncidps,varidps
       endif
 
@@ -106,7 +108,7 @@
       count(4)=0
 c  ps
-      status=NF_GET_VARA_REAL(ncidps,varidps,start,count,psnc)
+c     status=NF_GET_VARA_REAL(ncidps,varidps,start,count,psnc)
 c     call dump2d(iip1,jjp1,psnc,'PSNC COUCHE 1 ')
-      call correctbid(iim,jjp1,psnc)
+c     call correctbid(iim,jjp1,psnc)
 
 c   Transformations
@@ -187,10 +189,10 @@
 c -----------------------------------------------------------------
 
-      do j=1,jjp1
-         do i=1,iim
-            ps(i,j)=psnc(i,jjp1+1-j)
-         enddo
-         ps(iip1,j)=ps(1,j)
-      enddo
+c     do j=1,jjp1
+c        do i=1,iim
+c           ps(i,j)=psnc(i,jjp1+1-j)
+c        enddo
+c        ps(iip1,j)=ps(1,j)
+c     enddo
 
       CALL pression( ip1jmp1, ap, bp, ps, p )
@@ -200,5 +202,5 @@
       unskap=1./kappa
       prefkap =  preff  ** kappa
-      PRINT *,' Pref kappa unskap  ',preff,kappa,unskap
+c     PRINT *,' Pref kappa unskap  ',preff,kappa,unskap
       DO l = 1, llm
        DO j=1,jjp1
Index: /LMDZ.3.3/trunk/libf/dyn3d/redecoupenc.F
===================================================================
--- /LMDZ.3.3/trunk/libf/dyn3d/redecoupenc.F	(revision 203)
+++ /LMDZ.3.3/trunk/libf/dyn3d/redecoupenc.F	(revision 204)
@@ -1,9 +1,11 @@
+c
 c $Header
+c
       SUBROUTINE redecoupenc
      s     (irec,massemn,pbarun,pbarvn,wn,tetan,phin,
-     s     nrec,avant,airefi,
-     s     zmfu, zmfd, zen_u, zde_u,zen_d, zde_d, coefkz,
-     s     yu1,yv1,ftsol,pctsrf,
-     s     frac_impa,frac_nucl,phisn)
+     s     nrec,avant,airefin,phisfin,
+     s     tn,zmfu, zmfd, zen_u, zde_u,zen_d, zde_d, coefkzn,
+     s     yu1n,yv1n,ftsoln,pctsrfn,
+     s     frac_impan,frac_nucln,phisn)
 
       IMPLICIT NONE
@@ -11,13 +13,11 @@
 #include "dimensions.h"
 #include "paramet.h"
-
 #include "comvert.h"
 #include "comconst.h"
 #include "comgeom2.h"
-
 #include "tracstoke.h"
+#include "logic.h"
 
       integer irec,nrec,i,j
-
       integer ig,l
       integer imo,jmo,imn,jmn,ii,jj,ig
@@ -32,28 +32,6 @@
       real zmfd(ngridn,llm),zde_d(ngridn,llm),zen_d(ngridn,llm)
       real zmfu(ngridn,llm),zde_u(ngridn,llm),zen_u(ngridn,llm)
-      real mfd(ngridn,llm),de_d(ngridn,llm),en_d(ngridn,llm)
-      real mfu(ngridn,llm),de_u(ngridn,llm),en_u(ngridn,llm)
 	
-	real*4 airedy(iip1,jjp1)
-      real*4 rlonu_dy(iip1,jjp1),rlonv_dy(iip1,jjm),
-     . rlatu_dy(iip1,jjp1),rlatv_dy(iip1,jjm)
-
-      real coefkz(ngridn,llm)
-      real frac_impa(ngridn,llm),frac_nucl(ngridn,llm)
-      real yu1(ngridn), yv1(ngridn)
-      real ftsol(ngridn,nbsrf),pctsrf(ngridn,nbsrf)
-      integer imfu,imfd,ien_u,ide_u,
-     s      ien_d,ide_d,
-     s      icoefkz,izu1,izv1,
-     s      itsol,ipsf,
-     s      ilei, ilec
-      parameter(imfu=1,imfd=llm+1,ien_u=2*llm+1,ide_u=3*llm+1,
-     s      ien_d=4*llm+1,ide_d=5*llm+1,
-     s      icoefkz=6*llm+1,
-     s      ilei=7*llm+1,ilec=8*llm+1,
-     s      izu1=9*llm+1,izv1=9*llm+2,
-     s      itsol=9*llm+3,ipsf=9*llm+3+nbsrf)
-      logical avant
-
+       logical avant
 
       real massefi(ngridn,llm)
@@ -63,5 +41,5 @@
       real wn(imn+1,jmn+1,llm),phin(imn+1,jmn+1,llm)
       real phisn(imn+1,jmn+1)
-      real phisfi(imn,jmn+1)
+
       real massemo(imo+1,jmo+1,llm),tetao(imo+1,jmo+1,llm)
       real pbaruo(imo+1,jmo+1,llm),pbarvo(imo+1,jmo,llm)
@@ -71,22 +49,43 @@
       real pbarvst(imo+1,jmo+1,llm)
 
-      real airefi(ngridn)
-
-      real xlecn(ngridn,9*llm+2+2*nbsrf),tmpn(imn+1,jmn+1)
-      real xleco(ngrido,9*llm+2+2*nbsrf),tmpo(imo+1,jmo+1)
+      real tmpo2(imo+1,jmo+1,llm),tmpo1(imo,jmo+1,llm)
+      real tmpo4(imo+1,jmo+1,nbsrf),tmpo3(imo,jmo+1,nbsrf)
+      real tmpo6(imo+1,jmo+1),tmpo5(imo,jmo+1)
+      real tmpn6(imn+1,jmn+1),tmpn5(imn,jmn+1)
+      real tmpn2(imn+1,jmn+1,llm),tmpn1(imn,jmn+1,llm)
+      real tmpn4(imn+1,jmn+1,nbsrf),tmpn3(imn,jmn+1,nbsrf)
+
+	real airefio(ngrido),phisfio(ngrido),
+     .    mfuo(ngrido,llm),mfdo(ngrido,llm),en_uo(ngrido,llm),
+     .    de_uo(ngrido,llm),en_do(ngrido,llm),
+     .    de_do(ngrido,llm),coefkzo(ngrido,llm),
+     .    frac_impao(ngrido,llm),frac_nuclo(ngrido,llm),
+     .    yu1o(ngrido),yv1o(ngrido),ftsolo(ngrido,nbsrf),
+     .    pctsrfo(ngrido,nbsrf),to(ngrido,llm) 
+
+      real airefin(ngridn),phisfin(ngridn),
+     .    mfun(ngridn,llm),en_un(ngridn,llm),mfdn(ngridn,llm),
+     .    de_un(ngridn,llm),en_dn(ngridn,llm),
+     .    de_dn(ngridn,llm),coefkzn(ngridn,llm),
+     .    frac_impan(ngridn,llm),frac_nucln(ngridn,llm),
+     .    ftsoln(ngridn,nbsrf),yu1n(ngridn),yv1n(ngridn),
+     .    pctsrfn(ngridn,nbsrf),tn(ngridn,llm)
 
       real zcontrole(ngridn),zmass,tmpdyn(imn+1,jmn+1),zflux
 
-      real ziadvtrac,zrec,ziadvtrac2,zrec2
-      real zim,zjm,zlm,zklon,zklev
+      real ziadvtrac,ziadvtrac2,zrec2
+      integer zim,zjm,zlm,zklon,zklev,zrec
 
       real zpi
+
 c  longitudes et latitudes lues
-      real rlonul(1:imo+1),rlatvl(1:jmo)
-      real rlonvl(1:imo+1),rlatul(1:jmo+1)
+      real rlonul(imo+1,jmo+1),rlatvl(imo+1,jmo)
+      real rlonvl(imo+1,jmo),rlatul(imo+1,jmo+1)
 c  longitudes et latitudes anciennes
       real rlonuo(0:imo+1),rlatvo(0:jmo+1)
+      real rlonvo(0:imo+1),rlatuo(0:jmo+1)
 c  longitudes et latitudes nouvelles
       real rlonun(0:imn+1),rlatvn(0:jmn+1)
+      real rlonvn(0:imn+1),rlatun(0:jmn+1)
       real aireo(imo+1,jmo+1)
 
@@ -95,5 +94,5 @@
       real alphaxo(imo+1)
       real alpha(imn+1,jmn+1)
-
+       real alphat(imn+1,jmn+1,llm)
       real aa,uu(0:imo+1),vv(imo+1,0:jmo+1)
 
@@ -105,6 +104,9 @@
       integer i,j
       real dlatm,dlatp,dlonm,dlonp
-
-
+c abd
+       character*10 file
+       character*10 nom
+       character*2 str2
+c fin ab
       zpi=2.*asin(1.)
 
@@ -161,16 +163,25 @@
 
       iest(1)=0
+	print*,'iest(1)=0'
       do io=2,imo+1
          iest(io)=iest(io-1)+ndecx(io-1)
          iouest(io-1)=iest(io)
+	print*,'iest(',io,')=',iest(io),'iouest('
+     s              ,io-1,')=',iouest(io-1)
+	
       enddo
       iouest(imo+1)=iest(imo+1)+ndecx(imo+1)
+	print*,'iouest(',imo+1,')=',iouest(imo+1)
 
       jnord(1)=0
+	print*,'jnord(1)=0'
       do jo=2,jmo+1
          jnord(jo)=jnord(jo-1)+ndecy(jo-1)
          jsud(jo-1)=jnord(jo)
+        print*,'jnord(',jo,')=',jnord(jo),'jsud('
+     s              ,jo-1,')=',jsud(jo-1)
       enddo
       jsud(jmo+1)=jnord(jmo+1)+ndecy(jmo+1)
+	        print*,'jsud(',jmo+1,')=',jsud(jmo+1)
 
 c==================================================================
@@ -182,23 +193,9 @@
         CALL read_fstoke(0,
      .   zrec,zim,zjm,zlm,
-     .   rlonu_dy,rlonv_dy,rlatu_dy,rlatv_dy,aireo,phiso,
+     .   rlonul,rlonvl,rlatul,rlatvl,aireo,phiso,
      .   massemo,pbaruo,pbarvo,wo,tetao,phio)
-
-	print*,'zrec,zdtvr,ziadvtrac,zim,zjm,zlm'
+      
+      print*,'zrec,zdtvr,ziadvtrac,zim,zjm,zlm'
       print*,zrec,zdtvr,ziadvtrac,zim,zjm,zlm
-
-      if((imo-nint(zim))*(jmo-nint(zjm)).ne.0) then
-        print*,'Modifier les dimensions dans redecoupe '
-        print*,'Mettre imo=',zim,'   jmo=',zjm
-        stop
-      endif
-
-        CALL read_pstoke(0,
-     .   zrec,zklon,zklev,airefi,phisfi,
-     .   mfu,mfd,en_u,de_u,en_d,de_d,coefkz,
-     .   frac_impa,frac_nucl,yu1,yv1,ftsol,pctsrf)
-	
-	print*,'Entete du fichier physique'
-      print*,zrec2,ziadvtrac2,zklon,zklev
 
       nrec=zrec
@@ -207,4 +204,39 @@
       istphy=ziadvtrac2
 
+      print*,'rlonul '
+      do io=1,imo+1
+         print*,io,rlonul(io,1)
+      enddo
+	print*,'rlonvl '
+      do io=1,imo+1
+         print*,io,rlonvl(io,1)
+      enddo
+	print*,'rlatul '
+      do jo=1,jmo+1
+         print*,jo,rlatul(1,jo)
+      enddo
+	print*,'rlatvl'
+      do jo=1,jmo
+         print*,jo,rlatvl(1,jo)
+      enddo
+      
+c      if((imo-nint(zim))*(jmo-nint(zjm)).ne.0) then
+c        print*,'Modifier les dimensions dans redecoupe '
+c        print*,'Mettre imo=',zim,'   jmo=',zjm
+c  abderr      stop
+c      endif
+
+c abderrahmane
+	if(physic)then
+	CALL read_pstoke(0,
+     .   zrec,zklon,zklev,airefio,phisfio,
+     .   to,mfuo,mfdo,en_uo,de_uo,en_do,de_do,coefkzo,
+     .   frac_impao,frac_nuclo,yu1o,yv1o,ftsolo,pctsrfo)
+	
+	print*,'Entete du fichier physique'
+        print*,zrec,zklon,zklev
+	endif
+
+
 c==================================================================
 c   Definition des anciennes latitudes et longitudes
@@ -212,30 +244,50 @@
 c==================================================================
 
-      rlonuo(0)=-zpi
+
       do io=1,imo
-c        rlonuo(io)=2.*zpi/FLOAT(imo)*(io+0.5-0.5*FLOAT(imo)-1.)
-c        print*,'LON ',io,rlonuo(io),rlonul(io)
-         rlonuo(io)=rlonul(io)
-      enddo
-      rlonuo(imo+1)=zpi
+         rlonuo(io)=rlonul(io,1)*zpi/180.
+	print*,'LON ',io,rlonuo(io)*180./zpi
+      enddo
+c abderr
+      rlonuo(imo+1)=0.5*(rlonul(imo,1)+rlonul(imo+1,1))*zpi/180.
+      print*,'LON ',imo+1,rlonuo(imo+1)*180./zpi
+      rlonuo(0)=rlonuo(imo+1)-2.*zpi
+      print*,'LON ',0,rlonuo(0)*180./zpi
+
+c abder
+c ATTENTION A REVOIR
+c	goto 22
+      do io=1,imo
+         rlonvo(io)=rlonvl(io,1)*zpi/180.
+        print*,'LON ',io,rlonvo(io)*180./zpi
+      enddo
+      rlonvo(imo+1)=0.5*(rlonvl(imo,1)+rlonvl(imo+1,1))*zpi/180.
+      print*,'LON ',imo+1,rlonvo(imo+1)*180./zpi
+      rlonvo(0)=rlonvo(imo+1)-2.*zpi
+      print*,'LON ',0,rlonvo(0)*180./zpi
+22    continue
+c fin ab
 
       rlatvo(0)=zpi/2.
+      print*,'LAT ',0,rlatvo(0)*180./zpi
       do jo=1,jmo
-c        rlatvo(jo)=zpi/FLOAT(jmo)*(0.5*FLOAT(jmo)+1.-jo-0.5)
-c        print*,'LAT ',jo,rlatvo(jo),rlatvl(jo)
-         rlatvo(jo)=rlatvl(jo)
-      enddo
-      rlatvo(jmo+1)=-zpi/2.
-
-c     do jo=1,jmo+1
-c        do io=1,imo+1
-c           aireo(io,jo)=rad*rad
-c    s         *(rlonuo(io)-rlonuo(io-1))
-c    s         *(sin(rlatvo(jo-1))-sin(rlatvo(jo)))
-c           aireo(io,jo)=airel(io,jo)
-c        enddo
-c        aireo(1,jo)=aireo(1,jo)+aireo(imo+1,jo)
-c        aireo(imo+1,jo)=aireo(1,jo)
-c     enddo
+        rlatvo(jo)=rlatvl(1,jo)*zpi/180.
+	print*,'LAT ',jo,rlatvo(jo)*180./zpi
+      enddo
+	rlatvo(jmo+1)=-zpi/2.
+	print*,'LAT ',jmo+1,rlatvo(jmo+1)*180./zpi
+c abd
+c ATTENTION A REVOIR
+c	goto 33
+c      rlatuo(0)=zpi/2.
+c      print*,'LAT ',0,rlatuo(0)*180./zpi
+      do jo=1,jmo+1
+        rlatuo(jo-1)=rlatul(1,jo)*zpi/180.
+        print*,'LAT ',jo-1,rlatuo(jo-1)*180./zpi
+      enddo
+        rlatuo(jmo+1)=-zpi/2.
+        print*,'LAT ',jmo+1,rlatuo(jmo+1)*180./zpi
+33    continue
+c abd
 
       do io=2,imo
@@ -250,5 +302,6 @@
 c==================================================================
 
-      rlonun(0)=-zpi
+c Nouvelles longitudes rlonun
+      rlonun(0)=rlonuo(0)
       do io=1,imo+1
          do iin=1,iouest(io)-iest(io)
@@ -259,23 +312,53 @@
             alphax(in)=alphaxo(io)/ndecx(io)
             print787,io,rlonuo(io-1)*180./zpi,in
-     s      ,iest(io),iouest(io),rlonun(in)*180./zpi,alphax(in)
-         enddo
-      enddo
-
+     s  ,iest(io),iouest(io),rlonun(in)*180./zpi,alphax(in)
+         enddo
+      enddo
+
+c Nouvelles longitudes rlonvn
+c	goto 44
+      rlonvn(0)=rlonvo(0)
+      do io=1,imo+1
+         do iin=1,iouest(io)-iest(io)
+            in=iin+iest(io)
+            rlonvn(in)=
+     s      rlonvo(io-1)+iin*(rlonvo(io)-rlonvo(io-1))
+     s      /ndecx(io)
+            alphax(in)=alphaxo(io)/ndecx(io)
+            print787,io,rlonvo(io-1)*180./zpi,in
+     s  ,iest(io),iouest(io),rlonvn(in)*180./zpi,alphax(in)
+         enddo
+      enddo
+44    continue
+
+c Nouvelles latitudes rlatvn
       rlatvn(0)=0.5*zpi
       do jo=1,jmo+1
-         print*,'jo=',jo
          do jjn=1,jsud(jo)-jnord(jo)
             jn=jnord(jo)+jjn
-            rlatvn(jn)=rlatvo(jo-1)+jjn*(rlatvo(jo)-rlatvo(jo-1))
+            rlatvn(jn)=
+     s      rlatvo(jo-1)+jjn*(rlatvo(jo)-rlatvo(jo-1))
      s      /ndecy(jo)
             alphay(jn)=(sin(rlatvn(jn-1))-sin(rlatvn(jn)))
      s                /(sin(rlatvo(jo-1))-sin(rlatvo(jo)))
-            print787,jo,rlatvo(jo-1)*180./zpi,jn
-     s      ,jnord(jo),jsud(jo),rlatvn(jn)*180./zpi,alphay(jn)
-         enddo
-      enddo
-
-787   format(i5,f10.2,3(i5),2(f10.2))
+           print*,jn,rlatvn(jn)*180./zpi
+         enddo
+      enddo
+
+c Nouvelles latitudes rlatun
+c	goto 55
+      rlatun(0)=0.5*zpi
+      do jo=1,jmo+1
+         do jjn=1,jsud(jo)-jnord(jo)
+            jn=jnord(jo)+jjn
+            rlatun(jn)=
+     s      rlatuo(jo-1)+jjn*(rlatuo(jo)-rlatuo(jo-1))
+     s      /ndecy(jo)
+           print*,jn,rlatvn(jn)*180./zpi
+         enddo
+      enddo
+55    continue
+
+787   format(i5,f10.2,3(i5),2(f12.6))
       do in=1,imn
          rlonu(in)=rlonun(in)
@@ -295,8 +378,17 @@
          do in=1,imn
             alpha(in,jn)=alphax(in)*alphay(jn)
+	    alphat(in,jn,1)=alpha(in,jn)
          enddo
          alpha(imn+1,jn)=0.
-      enddo
-
+	 alphat(imn+1,jn,1)=0.
+      enddo
+c abderr 19 4 00
+	do l=2,llm
+	 do jn=1,jmn+1
+         do in=1,imn+1
+	  alphat(in,jn,l)=alphat(in,jn,1)
+         enddo
+	 enddo
+        enddo
 c     call dump2d(iip1,jjp1,alpha,'ALPHA   ')
 
@@ -358,14 +450,4 @@
 c     call dump2d(iip1,jjp1,aire,'AIRE   ')
 
-c     do jn=1,jjp1
-c        do in=1,iim
-c           aire(in,jn)=rad*rad*(sin(rlatvn(jn-1))-sin(rlatvn(jn)))
-c    s      *(rlonun(in)-rlonun(in-1))
-c           unsaire(in,jn)=1./aire(in,jn)
-c        enddo
-c        aire(iip1,jn)=aire(1,jn)
-c        unsaire(iip1,jn)=unsaire(1,jn)
-c     enddo
-c     call dump2d(iip1,jjp1,aire,'AIRE2   ')
       DO 42 j = 1,jjp1
       DO 41 i = 1,iim
@@ -404,6 +486,17 @@
          enddo
       enddo
-
-
+	Print*,'Fin irec=0'
+	go to 435
+      file='pbur'
+      call inigrads(11,iip1
+     s  ,rlonu,180./pi,-180.,180.,jjp1,rlatu,-90.,90.,180./pi
+     s  ,llm,presnivs,1.
+     s  ,1800.,file,'gcmq2 ')
+      file='pbvr'
+      call inigrads(12,iip1
+     s  ,rlonv,180./pi,-180.,180.,jjm,rlatv,-90.,90.,180./pi
+     s  ,llm,presnivs,1.
+     s  ,1800.,file,'gcmq2 ')
+435   continue
 c==================================================================
 c   Fin des initialisations
@@ -415,17 +508,19 @@
 c   Lecture des fichiers fluxmass et  physique:
 c   -----------------------------------------------------
-	
+	print*,'Entrer dans read_fstoke a irec=',irec
 	CALL read_fstoke(irec,
      .   zrec,zim,zjm,zlm,
-     .   rlonu_dy,rlonv_dy,rlatu_dy,rlatv_dy,aireo,phiso,
+     .   rlonul,rlonvl,rlatul,rlatvl,aireo,phiso,
      .   massemo,pbaruo,pbarvo,wo,tetao,phio)
 
-	do l=1,llm
-           do j=1,jmo
-              do i=1,imo+1
-                 pbarvo(i,j,l)=pbarvst(i,j,l)
-              enddo
-           enddo
-        enddo
+	print*,'Apres read_fstoke a irec=',irec
+
+c	do l=1,llm
+c           do j=1,jmo
+c              do i=1,imo+1
+c                 pbarvo(i,j,l)=pbarvst(i,j,l)
+c              enddo
+c           enddo
+c        enddo
 
          do l=1,llm
@@ -434,11 +529,11 @@
                   do jn=jnord(jo)+1,jsud(jo)
                      do in=iest(io)+1,iouest(io)
-                        wn(in,jn,l)=alpha(in,jn)*wo(io,jo,l)
-                        massemn(in,jn,l)=alpha(in,jn)
-     s                     *massemo(io,jo,l)
+c                        wn(in,jn,l)=alpha(in,jn)*wo(io,jo,l)
+c                        massemn(in,jn,l)=alpha(in,jn)
+		       wn(in,jn,l)=alphat(in,jn,l)*wo(io,jo,l)
+		       massemn(in,jn,l)=alphat(in,jn,l)
+     s                                *massemo(io,jo,l)
                         tetan(in,jn,l)=tetao(io,jo,l)
                         phin(in,jn,l)=phio(io,jo,l)
-c marine                
-                        phisn(i,jn) = phiso(io,jo)
                      enddo
                   enddo
@@ -450,10 +545,23 @@
                tetan(imn+1,jn,l)=tetan(1,jn,l)
                phin(imn+1,jn,l)=phin(1,jn,l)
-c marine
-                phisn(imn+1,jn)=phisn(1,jn)
-
-            enddo
-         enddo
-
+            enddo
+         enddo
+c Test massemn
+	print*,'MASSE DANS LA NOUVELLE GRILLE'
+	goto 908
+	do jo=1,jmo+1
+               do io=1,imo+1
+                  do jn=jnord(jo)+1,jsud(jo)
+                     do in=iest(io)+1,iouest(io)
+	print*,'massemn(',in,jn,1,')=',massemn(in,jn,1)
+        	     enddo
+                  enddo
+               enddo
+	enddo
+	do jn=1,jmn+1
+	print*,'massemn(',imn+1,jn,1,')=',massemn(imn+1,jn,1)
+        enddo
+908     continue
+	print*,'Fin calcul de massemn pour nouv. gril.'
          do l=1,llm
             do jo=1,jmo+1
@@ -478,4 +586,5 @@
             enddo
          enddo
+	print*,'Fin calcul de pbarun'
 	
 	do l=1,llm
